<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="关联类型" prop="type">
        <el-select v-model="queryParams.type" placeholder="请选择关联类型" clearable size="small">
          <el-option label="图纸" value="1" />
          <el-option label="配件" value="2" />
          <el-option label="装配模板" value="3" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
        >新增</el-button>
      </el-col>
     <!-- <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
        >修改</el-button>
      </el-col>-->
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
		      :loading="exportLoading"
          @click="handleExport"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="detailList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="批次号" align="center" prop="batchNo"/>
      <el-table-column label="关联类型" align="center" prop="type">
        <template slot-scope="scope">
          <span v-if="scope.row.type == '1'">图纸</span>
          <span v-if="scope.row.type == '2'">配件</span>
          <span v-else>装配模版</span>
        </template>
      </el-table-column>
      <el-table-column label="名称" align="center" prop="typeName" />
      <el-table-column label="配件数量" align="center" prop="number">
        <template slot-scope="scope">
          <span v-if="scope.row.type == '2'">{{ scope.row.number }}</span>
          <span v-else>-</span>
        </template>
      </el-table-column>
      </el-table-column>
      <el-table-column label="创建时间" align="center" prop="createTime" />
      <el-table-column label="创建人" align="center" prop="createBy" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
         <!-- <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
          >修改</el-button>-->
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改生产执行中间对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body destroy-on-close :close-on-click-modal="false">
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="关联类型" prop="type">
          <el-select style="width: 100%" v-model="form.type" placeholder="请选择关联类型">
            <el-option label="图纸" :value= "1" />
            <el-option label="配件" :value= "2" />
            <el-option label="装配模板" :value= "3" />
          </el-select>
        </el-form-item>
        <el-form-item label="名称" prop="typeId">
          <el-select style="width: 100%" v-model="form.typeId" v-if="form.type == '1'" placeholder="请选择图纸" clearable size="small">
            <el-option
              v-for="picture in pictureList"
              :key="picture.id"
              :label="picture.title"
              :value="picture.id"
            />
          </el-select>

          <el-select style="width: 100%" v-model="form.typeId"  v-if="form.type == '2'" placeholder="请选择配件" clearable size="small">
            <el-option
              v-for="store in storeInfoList"
              :key="store.id"
              :label="store.title"
              :value="store.id"
            />
          </el-select>

          <el-select style="width: 100%" v-model="form.typeId" v-if="form.type == '3'" placeholder="请选择转配模版" clearable size="small">
            <el-option
              v-for="mark in markList"
              :key="mark.id"
              :label="mark.title"
              :value="mark.id"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="配件数量" prop="number" v-if="form.type == 2">
          <el-input type="number" v-model="form.number" placeholder="请输入配件数量" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <!-- 新增 -->
    <AddDetail ref="add" :executeId="parseInt($route.query.id)"/>

  </div>
</template>

<script>
import { listDetail, getDetail, delDetail, addDetail, updateDetail, exportDetail } from "@/api/track/executeDetail";
import AddDetail from "./components/AddDetail";
import { drawInfoList } from "@/api/track/drawing";
import { getStores } from "@/api/track/store";
import { markInfoList } from "@/api/track/mark";
export default {
  name: "Detail",
  components: {
    AddDetail
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 生产执行中间表格数据
      detailList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        inspectId: null,
        type: null,
        typeId: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        type:[
          { required: true, message: "请选择关联类型", trigger: "change" }
        ],
        typeId:[
          { required: true, message: "请选择名称", trigger: "change" }
        ],
        number:[
          { required: true, message: "数量不能为空", trigger: "blur" }
        ]
      },
      pictureList: [],
      storeInfoList: [],
      markList: []
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询生产执行中间列表 */
    getList() {
      this.loading = true;
      listDetail(this.queryParams).then(response => {
        this.detailList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        inspectId: null,
        type: null,
        typeId: null,
        number: null,
        createTime: null,
        createId: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.queryParams.inspectId = this.$route.query.id;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      /*this.reset();
      this.open = true;
      this.title = "添加生产执行中间";*/
      this.$refs.add.openExecuteDetail();
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getDetail(id).then(response => {
        this.form = response.data;
        if(this.form.type == '1'){
          this.getPictureInfo();
        }
        if(this.form.type == '2'){
          this.getStoreInfo()
        }
        if(this.form.type == '3'){
           this.getMarkInfo();
        }
        this.open = true;
        this.title = "修改生产执行详情";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateDetail(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addDetail(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除生产执行详情编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delDetail(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有生产执行中间数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportDetail(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    },
    getPictureInfo(){
      drawInfoList().then(res =>{
        if(res.code == 200){
          this.pictureList = res.data;
        }
      })
    },
    getStoreInfo(){
      getStores().then(res =>{
        if(res.code == 200){
          this.storeInfoList = res.data;
        }
      })
    },
    getMarkInfo(){
      markInfoList().then(res =>{
        if(res.code == 200){
          this.markList = res.data;
        }
      })
    },
  }
};
</script>
